﻿using System.Collections.ObjectModel;

namespace Proxmox.SpiceLauncher.Extensions;
internal static class ObservableCollectionExtensions
{
    public static ObservableCollection<T> Sort<T>(this ObservableCollection<T> collection, Comparison<T> comparison)
    {
        var sortableList = new List<T>(collection);
        sortableList.Sort(comparison);
        for (int i = 0; i < sortableList.Count; i++)
        {
            collection.Move(collection.IndexOf(sortableList[i]), i);
        }
        return collection;
    }
}
