﻿using System.Text.Json.Serialization;

namespace Proxmox.SpiceLauncher.Models;

public class Settings{
    private string? _password;
    private string? _passwordEnc;
    public string? Server { get; set; }
    public string? Name { get; set; }
    public string? Username { get; set; }

    [JsonIgnore]
    public string? Password
    {
        get => _password;
        set
        {
            _password = value;
            _passwordEnc = value != null ? DPApi.EncryptStringToBase64(value) : null;
        }
    }

    public string? PasswordEnc
    {
        get => _passwordEnc;
        set
        {
            _passwordEnc = value;
            try
            {
                _password = value == null ? null : DPApi.DecryptStringFromBase64(value);
            }
            catch (Exception)
            {
                _password = null;
                _passwordEnc = null;
            }
        }
    }

    public override string ToString()
    {
        var server = (Username != null ? $"{Username}@" : null) + Server ?? "Unknown";
        if (Name != null)
        {
            return $"{Name} ({server})";
        }
        return server;
    }
}