﻿using System.Collections.ObjectModel;
using Proxmox.SpiceLauncher.Models;
using System.Windows;
using MahApps.Metro.Controls.Dialogs;
using Proxmox.SpiceLauncher.Extensions;

namespace Proxmox.SpiceLauncher;

/// <summary>
/// Interaction logic for SettingsWindow.xaml
/// </summary>
public partial class SettingsWindow
{
    private ObservableCollection<Settings> _settings;

    public SettingsWindow()
    {
        InitializeComponent();
    }

    public ObservableCollection<Settings> Settings
    {
        get => _settings;
        set
        {
            _settings = value;
            ListSettings.ItemsSource = _settings;
        }
    }

    private async void ButtonAdd_Click(object sender, RoutedEventArgs e)
    {
        var server = await this.ShowInputAsync("Proxmox Server", "Proxmox server IP or Hostname");
        if (string.IsNullOrEmpty(server))
            return;
        Settings.Add(new Settings
        {
            Server = server
        });
        Settings.Sort((a, b) => string.Compare(a.ToString(), b.ToString(), StringComparison.Ordinal));
    }

    private void ButtonDelete_Click(object sender, RoutedEventArgs e)
    {
        if (ListSettings.SelectedItem is Settings settings)
        {
            _settings.Remove(settings);
        }
    }
}